### Unconditionally uninstall a previous installation if found
Section "-remove_previous"
	StrCmp $OLD_UNINSTALLER "" gpg2

	DetailPrint "Uninstalling previous version"
	ExecWait "$OLD_UNINSTALLER /S _?=$OLD_INSTDIR"

	# Need to strip the quotes from $OLD_UNINSTALLER for Delete
	StrCpy $R0 $OLD_UNINSTALLER 1
	StrCmp $R0 `"` 0 +2
	StrCpy $OLD_UNINSTALLER $OLD_UNINSTALLER `` 1
	StrCpy $R0 $OLD_UNINSTALLER 1 -1
	StrCmp $R0 `"` 0 +2
	StrCpy $OLD_UNINSTALLER $OLD_UNINSTALLER -1
	Delete "$OLD_UNINSTALLER"
	RMDir "$OLD_INSTDIR"

	gpg2:

### uninstall gnupg2, gpa and its dependencies
### Uninstaller needs to have a similar section, doing the same work.
!include "gnupg-uninst.nsi"

SectionEnd


### Start of the installer section
${MementoSection} "-Claws-Mail" SEC_claws_mail

SetOutPath "$INSTDIR"

# Install the gcc and mingw32 runtime libraries
File "${gcc_dir}/${libstdcpp_dll}"
File "${gcc_dir}/${libgcc_dll}"
File "${libwinpthread_dir}/${libwinpthread_dll}"

### Now install files for each software component

#######################################
### bzip2
# Nothing to install, as we link statically

#######################################
### libiconv
!insertmacro SetPrefix libiconv
File ${prefix}/bin/libiconv-2.dll

#######################################
### libtasn1
!insertmacro SetPrefix libtasn1
File ${prefix}/bin/libtasn1-6.dll

#######################################
### regex
!insertmacro SetPrefix regex
File ${prefix}/bin/libregex-1.dll

#######################################
### zlib
!insertmacro SetPrefix zlib
File ${prefix}/bin/zlib1.dll

#######################################
### bsfilter
!insertmacro SetPrefix bsfilter
File ${prefix}/bin/bsfilterw.exe
File ${prefix}/bin/bsfilter.exe
File ${prefix}/bin/iconv.dll

#######################################
### gettext
!insertmacro SetPrefix gettext
File ${prefix}/bin/libintl-8.dll

#######################################
### libpng
!insertmacro SetPrefix libpng
File ${prefix}/bin/libpng16-16.dll

#######################################
### hunspell
!insertmacro SetPrefix hunspell
File ${prefix}/bin/libhunspell-1.7-0.dll

#######################################
### enchant
!insertmacro SetPrefix enchant
File ${prefix}/bin/libenchant-2.dll
SetOutPath "$INSTDIR\lib\enchant-2"
File ${prefix}/lib/enchant-2/enchant_hunspell.dll

SetShellVarContext all
SetOutPath "$INSTDIR\share\enchant"
File ${prefix}/share/enchant/enchant.ordering
SetOutPath "$INSTDIR\share\enchant\hunspell"
File dictionaries/en_US.aff
File dictionaries/en_US.dic
File dictionaries/de_DE_frami.aff
File dictionaries/de_DE_frami.dic
File dictionaries/fr.aff
File dictionaries/fr.dic
SetOutPath "$INSTDIR"

#######################################
### cyrus-sasl
!insertmacro SetPrefix cyrus_sasl
File ${prefix}/bin/libsasl2-3.dll
SetOutPath "$INSTDIR\lib\sasl2"
File ${prefix}/lib/sasl2/libanonymous-3.dll
File ${prefix}/lib/sasl2/libcrammd5-3.dll
File ${prefix}/lib/sasl2/libdigestmd5-3.dll
File ${prefix}/lib/sasl2/liblogin-3.dll
File ${prefix}/lib/sasl2/libplain-3.dll
SetOutPath "$INSTDIR"

#######################################
### libetpan
!insertmacro SetPrefix libetpan
File ${prefix}/bin/libetpan-20.dll

#######################################
### libassuan
!insertmacro SetPrefix libassuan
File ${prefix}/bin/libassuan${gpg_dll_num}-0.dll

#######################################
### libgpg-error
!insertmacro SetPrefix libgpg_error
File ${prefix}/bin/gpg-error.exe
File ${prefix}/bin/libgpg-error${gpg_dll_num}-0.dll

SetOutPath "$INSTDIR\share\locale\"
File /r ${prefix}/share/locale/
SetOutPath "$INSTDIR"

#######################################
### libffi
!insertmacro SetPrefix libffi
File ${prefix}/bin/libffi-8.dll

#######################################
### glib
!insertmacro SetPrefix glib
File ${prefix}/bin/libglib-2.0-0.dll
File ${prefix}/bin/libgmodule-2.0-0.dll
File ${prefix}/bin/libgobject-2.0-0.dll
File ${prefix}/bin/libgthread-2.0-0.dll
File ${prefix}/bin/libgio-2.0-0.dll

File ${prefix}/bin/gdbus.exe
File ${prefix}/bin/gio-querymodules.exe
File ${prefix}/bin/glib-compile-resources.exe
File ${prefix}/bin/glib-compile-schemas.exe
File ${prefix}/bin/gobject-query.exe
File ${prefix}/bin/gresource.exe
File ${prefix}/bin/gsettings.exe
!if ${nsis64} == "yes"
File ${prefix}/bin/gspawn-win64-helper.exe
File ${prefix}/bin/gspawn-win64-helper-console.exe
!else
File ${prefix}/bin/gspawn-win32-helper.exe
File ${prefix}/bin/gspawn-win32-helper-console.exe
!endif

SetOutPath "$INSTDIR\share\glib-2.0\schemas"
File ${prefix}/share/glib-2.0/schemas/gschema.dtd

SetOutPath "$INSTDIR\share\locale\"
File /r ${prefix}/share/locale/
SetOutPath "$INSTDIR"

#######################################
### expat
!insertmacro SetPrefix expat
File ${prefix}/bin/libexpat-1.dll

#######################################
### freetype
!insertmacro SetPrefix freetype
File ${prefix}/bin/libfreetype-6.dll

#######################################
### fontconfig
!insertmacro SetPrefix fontconfig
SetOutPath "$INSTDIR\etc\fonts"
File ${prefix}/etc/fonts/fonts.conf

SetOutPath "$INSTDIR"
File ${prefix}/bin/libfontconfig-1.dll

#######################################
### pixman
!insertmacro SetPrefix pixman
File ${prefix}/bin/libpixman-1-0.dll

#######################################
### cairo
!insertmacro SetPrefix cairo
File ${prefix}/bin/libcairo-2.dll
File ${prefix}/bin/libcairo-gobject-2.dll
File ${prefix}/bin/libcairo-script-interpreter-2.dll

#######################################
### harfbuzz
!insertmacro SetPrefix harfbuzz
File ${prefix}/bin/libharfbuzz-0.dll
File ${prefix}/bin/libharfbuzz-icu-0.dll

#######################################
### fribidi
!insertmacro SetPrefix fribidi
File ${prefix}/bin/libfribidi-0.dll

#######################################
### pango
!insertmacro SetPrefix pango
File ${prefix}/bin/libpango-1.0-0.dll
File ${prefix}/bin/libpangoft2-1.0-0.dll
File ${prefix}/bin/libpangowin32-1.0-0.dll
File ${prefix}/bin/libpangocairo-1.0-0.dll

#######################################
### atk
!insertmacro SetPrefix atk
File ${prefix}/bin/libatk-1.0-0.dll

SetOutPath "$INSTDIR\share\locale\"
File /r ${prefix}/share/locale/
SetOutPath "$INSTDIR"

#######################################
### gdk-pixbuf
!insertmacro SetPrefix gdk_pixbuf
File ${prefix}/bin/libgdk_pixbuf-2.0-0.dll
File ${prefix}/bin/gdk-pixbuf-query-loaders.exe
File ${prefix}/bin/gdk-pixbuf-pixdata.exe

#######################################
### gtk+
!insertmacro SetPrefix gtk
File ${prefix}/bin/libgdk-win32-2.0-0.dll
File ${prefix}/bin/libgtk-win32-2.0-0.dll

File ${prefix}/bin/libgailutil-18.dll
File ${prefix}/bin/gtk-query-immodules-2.0.exe

File ${prefix}/bin/gtk-update-icon-cache.exe

SetOutPath "$INSTDIR\etc\gtk-2.0"
File ${prefix}/etc/gtk-2.0/im-multipress.conf

SetOutPath "$INSTDIR\lib\gtk-2.0\2.10.0\engines"
File ${prefix}/lib/gtk-2.0/2.10.0/engines/libpixmap.dll
File ${prefix}/lib/gtk-2.0/2.10.0/engines/libwimp.dll

SetOutPath "$INSTDIR\lib\gtk-2.0\modules"
File ${prefix}/lib/gtk-2.0/modules/libgail.dll

SetOutPath "$INSTDIR\share\themes\Default\gtk-2.0-key"
File ${prefix}/share/themes/Default/gtk-2.0-key/gtkrc

SetOutPath "$INSTDIR\share\themes\Emacs\gtk-2.0-key"
File ${prefix}/share/themes/Emacs/gtk-2.0-key/gtkrc

SetOutPath "$INSTDIR\share\themes\Raleigh\gtk-2.0"
File ${prefix}/share/themes/Raleigh/gtk-2.0/gtkrc

SetOutPath "$INSTDIR\share\themes\MS-Windows\gtk-2.0"
File ${prefix}/share/themes/MS-Windows/gtk-2.0/gtkrc

SetOutPath "$INSTDIR\share\locale\"
File /r ${prefix}/share/locale/
SetOutPath "$INSTDIR"

#######################################
### gnutls
!insertmacro SetPrefix gnutls
File ${prefix}/bin/libgnutls-30.dll

#######################################
### curl
!insertmacro SetPrefix curl
File ${prefix}/bin/libcurl-4.dll

#######################################
### libxml2
!insertmacro SetPrefix libxml2
File ${prefix}/bin/libxml2-2.dll

#######################################
### libxslt
!ifndef DISABLE_FANCY_PLUGIN
!insertmacro SetPrefix libxslt
File ${prefix}/bin/libxslt-1.dll
!endif

#######################################
### gpgme
!insertmacro SetPrefix gpgme
File ${prefix}/bin/libgpgme-11.dll
File ${prefix}/bin/libgpgme-glib-11.dll
File ${prefix}/libexec/gpgme-w32spawn.exe

#######################################
### libwebp
!ifndef DISABLE_FANCY_PLUGIN
!insertmacro SetPrefix libwebp
File ${prefix}/bin/libwebp-7.dll
!endif

#######################################
### icu4c
!insertmacro SetPrefix icu4c
File ${prefix}/lib/icui18n58.dll
File ${prefix}/lib/icuuc58.dll
File ${prefix}/lib/icudata58.dll

#######################################
### sqlite-autoconf
!ifndef DISABLE_FANCY_PLUGIN
!insertmacro SetPrefix sqlite
File ${prefix}/bin/libsqlite3-0.dll
!endif

#######################################
### webkit
!ifndef DISABLE_FANCY_PLUGIN
!insertmacro SetPrefix webkitgtk
File ${prefix}/bin/libwebkitgtk-1.0-0.dll
File ${prefix}/bin/libjavascriptcoregtk-1.0-0.dll
!endif

#######################################
### jpeg
!insertmacro SetPrefix jpeg
File ${prefix}/bin/libjpeg-9.dll

#######################################
### glib-networking
!ifndef DISABLE_FANCY_PLUGIN
!insertmacro SetPrefix glib_networking
SetOutPath "$INSTDIR\lib\gio\modules"
File ${prefix}/lib/gio/modules/libgiognutls.dll
SetOutPath "$INSTDIR"
!endif

#######################################
### libpsl
!insertmacro SetPrefix libpsl
File ${prefix}/bin/libpsl-5.dll

#######################################
### libsoup
!ifndef DISABLE_FANCY_PLUGIN
!insertmacro SetPrefix libsoup
File ${prefix}/bin/libsoup-2.4-1.dll
!endif

#######################################
### gmp
!insertmacro SetPrefix gmp
File ${prefix}/bin/libgmp-10.dll

#######################################
### nettle
!insertmacro SetPrefix nettle
File ${prefix}/bin/libnettle-8.dll
File ${prefix}/bin/libhogweed-6.dll

#######################################
### libical
!insertmacro SetPrefix libical
File ${prefix}/bin/libical.dll
File ${prefix}/bin/libicalss.dll
File ${prefix}/bin/libicalvcal.dll

#######################################
### ytnef
!insertmacro SetPrefix ytnef
File ${prefix}/bin/libytnef-0.dll

#######################################
### gumbo-parser
!insertmacro SetPrefix gumbo_parser
File ${prefix}/bin/libgumbo-1.dll

#######################################
### poppler
!insertmacro SetPrefix poppler
File ${prefix}/bin/libpoppler-glib-8.dll
File ${prefix}/bin/libpoppler-120.dll

#######################################
### claws-mail
!insertmacro SetPrefix claws_mail
File ${prefix}/bin/claws-mail.exe
File ${prefix}/share/doc/claws-mail/manual/en/claws-mail-manual.pdf

SetOutPath "$INSTDIR\share\claws-mail"
File ${TOP_SRCDIR}/packages/ca-certificates.crt

SetOutPath "$INSTDIR\lib\claws-mail\plugins"
File ${prefix}/lib/claws-mail/plugins/address_keeper.dll
File ${prefix}/lib/claws-mail/plugins/attachwarner.dll
File ${prefix}/lib/claws-mail/plugins/att_remover.dll
File ${prefix}/lib/claws-mail/plugins/bsfilter.dll
!ifndef DISABLE_FANCY_PLUGIN
File ${prefix}/lib/claws-mail/plugins/fancy.dll
!endif
File ${prefix}/lib/claws-mail/plugins/fetchinfo.dll
File ${prefix}/lib/claws-mail/plugins/keyword_warner.dll
File ${prefix}/lib/claws-mail/plugins/libravatar.dll
File ${prefix}/lib/claws-mail/plugins/litehtml_viewer.dll
File ${prefix}/lib/claws-mail/plugins/managesieve.dll
File ${prefix}/lib/claws-mail/plugins/notification.dll
File ${prefix}/lib/claws-mail/plugins/pdf_viewer.dll
File ${prefix}/lib/claws-mail/plugins/pgpcore.dll
File ${prefix}/lib/claws-mail/plugins/pgpinline.dll
File ${prefix}/lib/claws-mail/plugins/pgpinline.deps
File ${prefix}/lib/claws-mail/plugins/pgpmime.dll
File ${prefix}/lib/claws-mail/plugins/pgpmime.deps
File ${prefix}/lib/claws-mail/plugins/rssyl.dll
File ${prefix}/lib/claws-mail/plugins/smime.dll
File ${prefix}/lib/claws-mail/plugins/smime.deps
File ${prefix}/lib/claws-mail/plugins/spamreport.dll
File ${prefix}/lib/claws-mail/plugins/tnef_parse.dll
File ${prefix}/lib/claws-mail/plugins/vcalendar.dll

SetOutPath "$INSTDIR\share\locale\"
File /r ${prefix}/share/locale/
SetOutPath "$INSTDIR"

DetailPrint "Writing VERSION file"
FileOpen $0 "$INSTDIR\VERSION" w
FileWrite $0 "${PACKAGE}$\r$\n"
FileWrite $0 "${VERSION}$\r$\n"
FileClose $0

${MementoSectionEnd}

${MementoSectionDone}

##############################################
### Windows Registry modification section
Section

!insertmacro MUI_INSTALLOPTIONS_READ $R0 "installer-setdefaultclient.ini" \
"Field 1" "State"
IntCmp $R0 0 skip_default_client

WriteRegStr   HKCU "SOFTWARE\Classes\mailto" "" "URL:MailTo-Protocol"
WriteRegStr   HKCU "SOFTWARE\Classes\mailto" "URL Protocol" ""
WriteRegDword HKCU "SOFTWARE\Classes\mailto" "EditFlags" 2
WriteRegStr   HKCU "SOFTWARE\Classes\mailto" "FriendlyTypeName" "Claws-Mail URL"
WriteRegStr   HKCU "SOFTWARE\Classes\mailto\DefaultIcon" "" "$INSTDIR\claws-mail.exe,0"
WriteRegStr   HKCU "SOFTWARE\Classes\mailto\shell\open\command" "" "$INSTDIR\claws-mail.exe --compose %1"
DetailPrint "Set Claws Mail as default mail client"

skip_default_client:
#just register Claws in the list of available mailers
WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail" "" "Claws Mail"
WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail" "DLLPath" ""

WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\Capabilities" "ApplicationDescription" "Fast, lightweight and user-friendly GTK+2 based email client"
WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\Capabilities" "ApplicationIcon" "$INSTDIR\claws-mail.exe,0"
WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\Capabilities" "ApplicationName" "Claws Mail"

WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\Capabilities\UrlAssociations" "mailto" "Claws-Mail.URL.mailto"

WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\Protocols\mailto" "" "URL:MailTo-Protocol"
WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\Protocols\mailto" "URL Protocol" ""
WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\Protocols\mailto" "FriendlyTypeName" "Claws-Mail URL"
WriteRegDword HKLM "SOFTWARE\Clients\Mail\Claws Mail\Protocols\mailto" "EditFlags" 2
WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\Protocols\mailto\DefaultIcon" "" "$INSTDIR\claws-mail.exe,0"
WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\Protocols\mailto\shell\open\command" "" "$INSTDIR\claws-mail.exe --compose %1"

WriteRegStr   HKLM "SOFTWARE\Clients\Mail\Claws Mail\shell\open\command" "" "$INSTDIR\claws-mail.exe"

WriteRegStr   HKLM "SOFTWARE\Classes\Claws-Mail.URL.mailto" "" "Claws-Mail URL"
WriteRegStr   HKLM "SOFTWARE\Classes\Claws-Mail.URL.mailto" "FriendlyTypeName" "Claws-Mail URL"
WriteRegStr   HKLM "SOFTWARE\Classes\Claws-Mail.URL.mailto" "URL Protocol" ""
WriteRegDword HKLM "SOFTWARE\Classes\Claws-Mail.URL.mailto" "EditFlags" 2

WriteRegStr   HKLM "SOFTWARE\Classes\Claws-Mail.URL.mailto\DefaultIcon" "" "$INSTDIR\claws-mail.exe,0"
WriteRegStr   HKLM "SOFTWARE\Classes\Claws-Mail.URL.mailto\shell\open\command" "" "$INSTDIR\claws-mail.exe --compose %1"

# Windows 8
WriteRegStr HKLM "SOFTWARE\RegisteredApplications" "Claws Mail" "Software\Clients\Mail\Claws Mail\Capabilities"

# Windows Add/Remove Programs support
Var /GLOBAL MYTMP
StrCpy $MYTMP "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRETTY_PACKAGE_SHORT}"
WriteRegExpandStr HKLM $MYTMP "UninstallString" '"$INSTDIR\claws-mail-uninstall.exe"'
WriteRegExpandStr HKLM $MYTMP "InstallLocation" "$INSTDIR"
WriteRegStr       HKLM $MYTMP "DisplayName"     "Claws Mail"
WriteRegStr       HKLM $MYTMP "DisplayIcon"     "$INSTDIR\claws-mail.exe,0"
WriteRegStr       HKLM $MYTMP "DisplayVersion"  "${VERSION}"
WriteRegStr       HKLM $MYTMP "Publisher"       "${COMPANY}"
WriteRegStr       HKLM $MYTMP "URLInfoAbout"    "${WEBSITE}"
WriteRegDWORD     HKLM $MYTMP "NoModify"        "1"
WriteRegDWORD     HKLM $MYTMP "NoRepair"        "1"
DetailPrint "Added Claws Mail info to Add/Remove Programs list"

SectionEnd

### Create the uninstaller and shortcuts
Section
WriteUninstaller "$INSTDIR\claws-mail-uninstall.exe"

# Delete the old stuff, also old names of previous versions.
Delete "$DESKTOP\Claws-Mail.lnk"
Delete "$DESKTOP\Claws-Mail Manual.lnk"

# Start Menu
!insertmacro MUI_INSTALLOPTIONS_READ $R0 "installer-options.ini" \
	"Field 2" "State"
	IntCmp $R0 0 no_start_menu

	SetOutPath "$INSTDIR"

	CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER"

	CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Claws-Mail.lnk" \
		"$INSTDIR\claws-mail.exe" \
		"" "" "" SW_SHOWNORMAL "" $(T_Menu_ClawsMail)

	CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Claws-Mail Manual.lnk" \
		"$INSTDIR\claws-mail-manual.pdf" \
		"" "" "" SW_SHOWNORMAL "" $(T_Menu_ClawsMailManual)

	CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Uninstall.lnk" \
		"$INSTDIR\claws-mail-uninstall.exe" \
		"" "$INSTDIR\claws-mail-uninstall.exe" "" SW_SHOWNORMAL "" $(T_Menu_Uninstall)

	no_start_menu:

# Desktop
!insertmacro MUI_INSTALLOPTIONS_READ $R0 "installer-options.ini" \
	"Field 3" "State"
	IntCmp $R0 0 no_desktop

	SetOutPath "$INSTDIR"

	CreateShortCut "$DESKTOP\Claws-Mail.lnk" \
		"$INSTDIR\claws-mail.exe" \
		"" "" "" SW_SHOWNORMAL "" $(T_Menu_ClawsMail)
	
	no_desktop:

# Quick Launch
!insertmacro MUI_INSTALLOPTIONS_READ $R0 "installer-options.ini" \
	"Field 4" "State"
	IntCmp $R0 0 no_quicklaunch

	SetOutPath "$INSTDIR"

	CreateShortCut "$QUICKLAUNCH\Claws-Mail.lnk" \
		"$INSTDIR\claws-mail.exe" \
		"" "" "" SW_SHOWNORMAL "" $(T_Menu_ClawsMail)

	no_quicklaunch:

SectionEnd

